"use strict";

module.exports = function mapAttributeFlags(flagAsNumber) {
	if (flagAsNumber & 128 || flagAsNumber & 64) {
		throw new Error(`Encountered unknown flag byte in flag ${flagAsNumber.toString(16).padStart(4, "0")}`);
	} else {
		return {
			autoKeep: Boolean(flagAsNumber & 32),
			eventCount: Boolean(flagAsNumber & 16),
			errorRate: Boolean(flagAsNumber & 8),
			affectsPerformance: Boolean(flagAsNumber & 4),
			updatedOnline: Boolean(flagAsNumber & 2),
			indicatesFailure: Boolean(flagAsNumber & 1),
		};
	}
};
