"use strict";

const graphql = require("graphql");

module.exports = function createGraphQLInterface(schema, options, root) {
	return function makeQuery(query, args) {
		return graphql.graphql({
			schema: schema,
			source: query,
			rootValue: root,
			contextValue: {
				data: (options.loaderFactory != null) ? options.loaderFactory() : {}
			},
			variableValues: args
		});
	};
};
