"use strict";

const Promise = require("bluebird");
const util = require("util");

const lsblk = require("./packages/exec-lsblk");
const lvm = require("./packages/exec-lvm");
const smartctl = require("./packages/exec-smartctl");
const findmnt = require("./packages/exec-findmnt");
const nvmeCli = require("./packages/exec-nvme-cli");

return Promise.try(() => {
	// return lvm.getVersions();
	// return lvm.getPhysicalVolumes();
	// return lvm.createPhysicalVolume({ devicePath: "/dev/loop0" });
	// return lvm.createPhysicalVolume({ devicePath: process.argv[2] });
	// return lvm.createVolumeGroup({ name: "not a valid name", physicalVolumes: ["/dev/loop0", "/dev/asdfasdfasdf", "/dev/gasdfgasdf"] });
	// return lvm.createVolumeGroup({ name: "vg-name", physicalVolumes: ["/dev/loop0", "/dev/asdfasdfasdf", "/dev/gasdfgasdf"] });
	// return lvm.createVolumeGroup({ name: "vg-name", physicalVolumes: ["/dev/loop0", "/dev/loop1", "/dev/loop2"] });
	// return lvm.createVolumeGroup({ name: "vg-name", physicalVolumes: ["/dev/loop0", "/dev/loop1"] });
	// return lvm.createVolumeGroup({ name: "vg-name2", physicalVolumes: ["/dev/loop0", "/dev/loop1"] });
	// return lvm.addVolumeToVolumeGroup({ volumeGroup: "vg-name2", physicalVolume: "/dev/loop0" });
	// return lvm.addVolumeToVolumeGroup({ volumeGroup: "vg-name2", physicalVolume: "/dev/sfasdfasdfasdf" });
	// return lvm.addVolumeToVolumeGroup({ volumeGroup: "vg-name2", physicalVolume: "/dev/loop1" });
	// return lvm.addVolumeToVolumeGroup({ volumeGroup: "vg-name2", physicalVolume: "/dev/loop2" });
	// return lvm.addVolumeToVolumeGroup({ volumeGroup: "vg-name", physicalVolume: "/dev/loop1" });
	// return lvm.destroyPhysicalVolume({ devicePath: "/dev/loop0" });
	// return lsblk();
	return smartctl.scan();
	// return smartctl.info({ devicePath: "/dev/sda" })
	// return smartctl.info({ devicePath: process.argv[2] })
	// return smartctl.attributes({ devicePath: process.argv[2] });
	// return findmnt();
	// return nvmeCli.listNamespaces({ devicePath: "/dev/nvme0" });
}).then((result) => {
	console.log(util.inspect(result, {colors: true, depth: null}));
}).catch((err) => {
	if (err.getAllContext != null) {
		let context = err.getAllContext()
		console.log(context);
		console.log("####################\n");
	}

	if (err.showChain != null) {
		// console.log(err.showChain({ allStacktraces: true }));
		console.log(err.showChain({}));
	} else {
		console.log(err.stack);
	}
});
